#include<bits/stdc++.h>
#include<string>
using namespace std;
int pal(string s){
    int i=0, j=s.length()-1;
    while(i<j){
        if(s[i]!=s[j]) cout<<0<<endl;
        i++;
        j--;
    }
    cout<<1<<endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, q,t, u , v;
    string c;
    cin>>n;
    vector<string> a(100002);
    string s="";
    cin>>q;
    for(int i=0; i<=100001; i++){
        a[i] = s;
    }
    for(int i=0; i<q; i++){
        cin>>t;
        if(t==1){
            cin>>u>>v>>c;
            a[v] = a[u] +=c;
        }
        if(t==2){
            cin>>u>>v;
            s = a[v];
            pal(s.substr(u-1, v-u));

        }
    }

}